'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _typeof2 = require('babel-runtime/helpers/typeof');

var _typeof3 = _interopRequireDefault(_typeof2);

var _keys = require('babel-runtime/core-js/object/keys');

var _keys2 = _interopRequireDefault(_keys);

exports.transform = transform;
exports.find = find;
exports.findIndex = findIndex;
exports.contains = contains;

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/* eslint-disable no-bitwise, no-plusplus */

function transform(obj, iteratee, accumulator) {
  (0, _keys2.default)(obj).forEach(function (key) {
    iteratee(accumulator, obj[key], key);
  });
  return accumulator;
}

function find(arr, pred) {
  var index = findIndex(arr, pred);
  return index > -1 ? arr[index] : undefined;
}

function findIndex(arr, pred) {
  var predType = typeof pred === 'undefined' ? 'undefined' : (0, _typeof3.default)(pred);
  for (var i = 0; i < arr.length; i++) {
    if (predType === 'function' && pred(arr[i], i, arr) === true) {
      return i;
    }
    if (predType === 'object' && contains(arr[i], pred)) {
      return i;
    }
    if (['string', 'number', 'boolean'].indexOf(predType) !== -1) {
      return arr.indexOf(pred);
    }
  }
  return -1;
}

function contains(obj, pred) {
  for (var _key in pred) {
    if (!obj.hasOwnProperty(_key) || obj[_key] !== pred[_key]) {
      return false;
    }
  }
  return true;
}